#include <iostream>
#include <cstring>
using namespace std;
struct Pacijent
{
    int j;
    char k;
};
int main()
{
    int o,a,b,ab,n,po,z;
    scanf(" %d", &n);
    scanf(" %d %d %d %d", &o, &a, &b, &ab);
    Pacijent* p = new Pacijent[n];
    z=o+a+b+ab;
    for(int i=0;i<n;i++)
    {

        scanf(" %c %d", &(p[i].k), &(p[i].j));
    }
    for(int i=0;i<n;i++)
        po+=p[i].j;
    if(z<po)
       cout<<"nemoguce";
    else
    {
        for(int i=0;i<n;i++)
        {
            if(strcmp(p[i].k,"O")==0)
            {
                if(p[i].j-o<0){
                cout<<"nemoguce";
                break;
            }else { o-p[i].j;}
            if(strcmp(p[i].k,"A")==0)
            {
                if(p[i].j-o<0 && p[i].j-a<0)
                {
                    cout<<"nemoguce";
                    break;
                }
            }else{if(o==0 && a>p[i].j)a-p[i].j; else if(o>p[i].j || o==p[i].j)o-p[i].j; else a-p[i].j;}
            if(strcmp(p[i].k,"B")==0)
            {
                if(p[i].j-o<0 && p[i].j-b<0)
                {
                    cout<<"nemoguce";
                    break;
                }
            }else{if(o==0 && b>p[i].j)b-p[i].j; else if(o>p[i].j || o==p[i].j)o-p[i].j; else b-p[i].j;}
             if(strcmp(p[i].k,"AB")==0)
            {
                if(p[i].j-o<0 && p[i].j-b<0)
                {
                    cout<<"nemoguce";
                    break;
                }
            }else{if(o==0 && b>p[i].j)b-p[i].j; else if(o>p[i].j || o==p[i].j)o-p[i].j; else b-p[i].j;else{if(o==0 && a>p[i].j)a-p[i].j; else if(o>p[i].j || o==p[i].j)o-p[i].j; else a-p[i].j;}}
        }
    }
        for(int i=0;i<n;i++)
            cout<<"moguce";
        
    }
    delete[] p;
    return 0;
}